<?php

require_once 'hotspots.field.widget.inc';
require_once 'hotspots.field.formatter.inc';

/**
 * Implements hook_field_info().
 */
function hotspots_field_info() {
  return array(
    'hotspot' => array(
      'label' => t('Hot-spot'),
      'description' => t('This field stores image hot-spots in the database.'),
      'default_widget' => 'hotspot_default',
      'default_formatter' => 'hotspot_default',
    ),
  );
}

/**
 * Implements hook_field_presave().
 */
function hotspots_field_presave($entity_type, $entity, $field, $instance, $langcode, &$items) {
  foreach ($items as &$item) {
    unset($item['status']);
    $values = $item;
    $item = array();
    $item['fid'] = $values['fid'];
    unset($values['fid']);
    $item['params'] = serialize($values);
  }
}

/**
 * Implements hook_field_load().
 */
function hotspots_field_load($entity_type, $entities, $field, $instances, $langcode, &$items, $age) {
 foreach ($entities as $id => $entity) {
    foreach ($items[$id] as &$item) {
      $item += unserialize($item['params']);
      unset($item['params']);
    }
  }
}

/**
 * Implements hook_field_is_empty().
 */
function hotspots_field_is_empty($item, $field) {
  if (
      !is_numeric($item['fid'])
      || empty($item['title'])
      || empty($item['value'])
      || empty($item['coords_x1'])
      || empty($item['coords_y1'])
      || empty($item['coords_x2'])
      || empty($item['coords_y2'])
     ) {
    return TRUE;
  }
  return FALSE;
}

function _hotspots_format_styles($styles) {
  foreach($styles as $style => $style_value) {
    $styles[$style] = $style . ': ' . $style_value;
  }
  return implode('; ', $styles);
}
