(function ($) {
// @todo clean up this file
$(function(){
  
  hotspots_view();
  hotspots_edit();
  
  function hotspots_view() {
    
    var hotspots = $('.hotspots-view');
    var hotspots_images = $('.image', hotspots);
    
    var hotspots_image;
    var hotspots_popup;
    var hotspots_fields;
    
    $('.hotspots-view .hotspots-pointers .title').hover(function(){
      hotspots_hotspot_toggle_by_pointer($(this));
    }, function(){
      hotspots_hotspot_toggle_by_pointer($(this));
    });
    
    // Hotspot
    hotspots_images.hover(function(){
      hotspots_set_variables($(this));
      hotspots_enable_hotspots_popup();
    }, function(){
      hotspots_disable_hotspots_popup();
      hotspots_unset_variables();
    });
    
    function hotspots_set_variables(hotspots_image_parent) {
      hotspots_image = $('img:first', hotspots_image_parent);
      hotspots_popup = $('.hotspots-popup', hotspots_image_parent);
      hotspots_fields = $('.hotspot-pointer .hidden-values', hotspots_image_parent.closest('.hotspots-view'));
    }
    
    function hotspots_unset_variables() {
      hotspots_image = null;
      hotspots_popup = null;
      hotspots_fields = null;
    }
    
    function hotspots_hotspot_toggle_by_pointer(pointer) {
      var index = $('.index', pointer.closest('.hotspot-pointer')).val();
      $('.image .overlay', pointer.closest('.hotspots-view')).toggle();
      $('.image .hotspots .hotspot.index-' + index, pointer.closest('.hotspots-view')).toggle();
    }
    
    // Timeout variables.
    // Make it global for several functions.
    var hotspots_popup_event_object;
    var hotspots_popup_timeout;

    /**
     * Enable hotspot popup
     */
    function hotspots_enable_hotspots_popup() {
      hotspots_image.bind('mousemove', hotspots_popup_mousemove);
    }
    
    /**
     * Disable hotspot popup
     */
    function hotspots_disable_hotspots_popup() {
      hotspots_image.unbind('mousemove');
      clearTimeout(hotspots_popup_timeout);
      hotspots_popup_event_object = null;
      hotspots_popup_hide();
    }

    function hotspots_popup_mousemove(eventObject){
      hotspots_popup_event_object = eventObject;
      clearTimeout(hotspots_popup_timeout);
      hotspots_popup_timeout = setTimeout(hotspots_popup_show, 5);
    }

    /**
     * Show popup
     */
    function hotspots_popup_show() {
      var event_hotspots = hotspots_detect_eventing_hotspots();
      var values = hotspots_get_hotspots_values(event_hotspots);
      
      if (values.length) {
        var html = Drupal.theme('hotspots_popup', values);
        var clickedCoords = hotspots_get_event_coords();
        hotspots_popup.css({'left': clickedCoords.x, 'top': clickedCoords.y});
        hotspots_popup.html(html).fadeIn(200);
        hotspots_popup.hover(function(){
          hotspots_image.unbind('mousemove');
          clearTimeout(hotspots_popup_timeout);
        },function(){
          hotspots_enable_hotspots_popup();
        });
      }
      else {
        hotspots_popup_hide();
      }
    }

    /**
     * Hide popup
     */
    function hotspots_popup_hide() {
      hotspots_popup.fadeOut(200);
    }

    /**
     * Define eventing hotspots
     */
    function hotspots_detect_eventing_hotspots() {
      var eventing_hotspots = [];
      var eventCoords = hotspots_get_event_coords();

      hotspots_fields.each(function(index, hotspot_form_element){
        
        var hotspot_coords = hotspots_get_coords_to_hotspot(hotspot_form_element);
        if (
          eventCoords['x'] >= hotspot_coords['x1']
          && eventCoords['x'] <= hotspot_coords['x2']
          && eventCoords['y'] >= hotspot_coords['y1']
          && eventCoords['y'] <= hotspot_coords['y2']
        ) {
          eventing_hotspots.push(hotspot_form_element);
        }
      });
      return  eventing_hotspots;
    }

    function hotspots_get_event_coords() {
      var eventCoords = {};
      var hotspot_image_offset = $(hotspots_popup_event_object.currentTarget).offset();
      eventCoords['x'] = hotspots_popup_event_object.pageX - hotspot_image_offset.left;
      eventCoords['y'] = hotspots_popup_event_object.pageY - hotspot_image_offset.top;
      return eventCoords;
    }

    /**
     * Get values from hotspots.
     */
    function hotspots_get_hotspots_values(hotspots) {
      var values = [];
      for (var index in hotspots) {
        var hotspot = hotspots[index];
        var value = {};
        value['title'] = $('.title', hotspot).val();
        value['value'] = $('.value', hotspot).val();
        values.push(value);
      }
      return values;
    }
    
    /**
     * Get coordinates from element forms to static hotspot.
     */
    function hotspots_get_coords_to_hotspot(hotspot) {
      var coords = {};
      coords['x1'] = Math.round($('.coords-x1', hotspot).val() * hotspots_image.attr('width'));
      coords['y1'] = Math.round($('.coords-y1', hotspot).val() * hotspots_image.attr('height'));
      coords['x2'] = Math.round($('.coords-x2', hotspot).val() * hotspots_image.attr('width'));
      coords['y2'] = Math.round($('.coords-y2', hotspot).val() * hotspots_image.attr('height'));
      return coords;
    }
    
  }
  
  function hotspots_edit() {

    /**
     * Local variables definition.
     */
    var hotspots = $('.hotspots-edit .image'); // @todo: убрать .image
    var hotspots_image = $('img:first', hotspots);
    var hotspots_items = $('.hotspots', hotspots);
    var hotspots_popup = $('.hotspots-popup', hotspots);
    var hotspots_fields = $('.hotspots-field .hotspot-item');
    var current_hotspot;
    var current_hotspot_index;
    var jCrop_api;

    hotspots_binding_handlers();

    /**
     * Binding handlers.
     */
    function hotspots_binding_handlers() {
      // Hotspot enable binding.
      $('.title-label', hotspots_fields).live('click', function(){
        hotspots_hotspot_enable($(this).closest('.hotspot-item'));
      });

      // Hotspot disable binding.
      $('.submit', hotspots_fields).live('click', function(){
        hotspots_hotspot_disable();
      });

      // Hotspot 
      hotspots.hover(function(){
        hotspots_enable_hotspots_popup();
      }, function(){
        hotspots_disable_hotspots_popup();
      });
    }

    /**
     * Enable hotspot.
     */
    function hotspots_hotspot_enable(hotspot) {
      hotspots_refresh_current_hotspot();
      hotspots_set_current_hotspot(hotspot);

      current_hotspot.addClass('expanded').removeClass('collapsed');
      $('.status', current_hotspot).val('expanded');
      hotspots_hotspot_jcrop_enable();
    }

    /**
     * Disable hotspot.
     */
    function hotspots_hotspot_disable() {
      hotspots_refresh_current_hotspot();
      current_hotspot.addClass('collapsed').removeClass('expanded');
      $('.status', current_hotspot).val('collapsed');
      hotspots_hotspot_jcrop_disable();

      hotspots_unset_current_hotspot();
    }


    /**
     * Enable hotspot jquery image crop.
     */
    function hotspots_hotspot_jcrop_enable() {
      var coords = hotspots_transfer_hotspot_to_jcrop();
      var params = {
        onChange:   hotspots_get_coords,
        onSelect:   hotspots_get_coords,
        onRelease:  hotspots_clear_coords,
        bgOpacity: 1,
        borderOpacity: 1,
        handleOpacity: 1,
        handleSize: 5,
        handleOffset: 3
      };
      if (coords) {
        params['setSelect'] = [coords['x1'], coords['y1'], coords['x2'], coords['y2']];
      }
      hotspots_image.Jcrop(params, function() {
        jCrop_api = this;
        $('div:first-child', hotspots_image.next()).addClass('new-hotspot index-' + current_hotspot_index);
      });
    }

    /**
     * Disable hotspot jquery image crop.
     */
    function hotspots_hotspot_jcrop_disable() {
      hotspots_transfer_hotspot_from_jcrop();
      jCrop_api.destroy();
    }

    /**
     * Transfer hotspot from jcrop.
     */
    function hotspots_transfer_hotspot_from_jcrop() {
      if ($('.title', current_hotspot).val()) {
        $('.title-label', current_hotspot).text($('.title', current_hotspot).val());
      }
      else {
        $('.title-label', current_hotspot).text(Drupal.t('New hotspot'));
      }
      var coords = hotspots_get_coords_to_hotspot(current_hotspot);
      if (!(coords['x2'] - coords['x1']) || !(coords['y2'] - coords['y1'])) {
        return;
      }
      var vars = {};
      var styles = {};
      styles['left'] = 'left:' + coords['x1'] + 'px;';
      styles['top'] = 'top:' + coords['y1'] + 'px;';
      styles['width'] = 'width:' + (coords['x2'] - coords['x1']) + 'px;';
      styles['height'] = 'height:' + (coords['y2'] - coords['y1']) + 'px;';
      vars['hotspot_index'] = current_hotspot_index;
      vars['hotspot_styles'] = styles['left'] + ' ' + styles['top'] + ' ' + styles['width'] + ' ' + styles['height'];
      var hotspot = $('.index-' + current_hotspot_index, hotspots_items);
      if (hotspot.length) {
        hotspot.show().attr('style', vars['hotspot_styles']);
      }
      else {
        hotspots_items.append(Drupal.theme('hotspots_hotspot', vars));
      }
    }

    /**
     * Transfer hotspot to jcrop.
     */
    function hotspots_transfer_hotspot_to_jcrop() {
      var coords = '';
      var hotspot = $('.index-' + current_hotspot_index, hotspots_items);
      if (hotspot.length) {
        coords = hotspots_get_coords_from_hotspot(hotspot);
        hotspot.hide();
      }
      return coords;
    }

    /**
     * Set hotspot as current hotspot.
     */
    function hotspots_set_current_hotspot(hotspot) {
      if (current_hotspot) {
        hotspots_hotspot_disable(current_hotspot);
      }
      current_hotspot = hotspot;
      current_hotspot_index = hotspots_fields.index(current_hotspot);
    }

    /**
     * Unset current hotspot.
     */
    function hotspots_unset_current_hotspot() {
      hotspots_refresh_current_hotspot();
      current_hotspot = '';
      current_hotspot_index = '';
    }

    /**
     * Refresh current hotspot if it was recreated from DOM.
     * 
     * Example: we have 3 hotspots, after we pressed "Add new hotspot"
     * ajax remove 3 old hotspots and add 4 new hotspots.
     * But variable current_hotspot is linked with one of 3 old hotspot, 
     * but we need that current_hotspot is linked with the same hotspot in 4 new hotspots.
     */
    function hotspots_refresh_current_hotspot() {
      hotspots_fields = $('.hotspots-field .hotspot-item');
      if (current_hotspot && !current_hotspot.closest('html').length) {
        current_hotspot = $('.hotspots-field .hotspot-item.expanded');
      }
    }

    /**
     * Get coordinates from jcrop to element forms.
     */
    function hotspots_get_coords(coords) {
      hotspots_refresh_current_hotspot();
      var coords_x1 = coords.x/hotspots_image.attr('width');
      var coords_y1 = coords.y/hotspots_image.attr('height');
      var coords_x2 = coords.x2/hotspots_image.attr('width');
      var coords_y2 = coords.y2/hotspots_image.attr('height');

      $('.fid', current_hotspot).val(hotspots_image.siblings('.image-fid').first().val());
      $('.coords-x1', current_hotspot).val(coords_x1.toFixed(4));
      $('.coords-y1', current_hotspot).val(coords_y1.toFixed(4));
      $('.coords-x2', current_hotspot).val(coords_x2.toFixed(4));
      $('.coords-y2', current_hotspot).val(coords_y2.toFixed(4));
    }

    /**
     * Get coordinates from element forms to static hotspot.
     */
    function hotspots_get_coords_to_hotspot(hotspot) {
      var coords = {};
      coords['x1'] = Math.round($('.coords-x1', hotspot).val() * hotspots_image.attr('width'));
      coords['y1'] = Math.round($('.coords-y1', hotspot).val() * hotspots_image.attr('height'));
      coords['x2'] = Math.round($('.coords-x2', hotspot).val() * hotspots_image.attr('width'));
      coords['y2'] = Math.round($('.coords-y2', hotspot).val() * hotspots_image.attr('height'));
      return coords;
    }

    /**
     * Get coordinates from static hotspot to jcrop.
     */
    function hotspots_get_coords_from_hotspot(hotspot) {
      var coords = {};
      coords['x1'] = parseInt(hotspot.css('left'));
      coords['y1'] = parseInt(hotspot.css('top'));
      coords['x2'] = parseInt(hotspot.css('left')) + parseInt(hotspot.css('width'));
      coords['y2'] = parseInt(hotspot.css('top')) + parseInt(hotspot.css('height'));
      return coords;
    }

    /**
     * Clear coordinates from element forms.
    */
    function hotspots_clear_coords() {
      $('.image-fid', current_hotspot).val('');
      $('.coords-x1', current_hotspot).val('');
      $('.coords-y1', current_hotspot).val('');
      $('.coords-x2', current_hotspot).val('');
      $('.coords-y2', current_hotspot).val('');
    }
    
    
    // Timeout variables.
    // Make it global for several functions.
    var hotspots_popup_event_object;
    var hotspots_popup_timeout;

    /**
     * Enable hotspot popup
     */
    function hotspots_enable_hotspots_popup() {
      if (!current_hotspot) {
        hotspots.bind('mousemove', hotspots_popup_mousemove);
      }
    }
    
    /**
     * Disable hotspot popup
     */
    function hotspots_disable_hotspots_popup() {
      hotspots.unbind('mousemove');
      clearTimeout(hotspots_popup_timeout);
      hotspots_popup_event_object = null;
      hotspots_popup_hide();
    }

    function hotspots_popup_mousemove(eventObject){
      hotspots_popup_event_object = eventObject;
      clearTimeout(hotspots_popup_timeout);
      hotspots_popup_timeout = setTimeout(hotspots_popup_show, 200);
    }

    /**
     * Show popup
     */
    function hotspots_popup_show() {
      var event_hotspots = hotspots_detect_eventing_hotspots();
      var values = hotspots_get_hotspots_values(event_hotspots);
      if (values.length) {
        var html = Drupal.theme('hotspots_popup', values);
        var clickedCoords = hotspots_get_clicked_coords();
        hotspots_popup.css({'left': clickedCoords.x, 'top': clickedCoords.y});
        hotspots_popup.html(html).fadeIn(200);
        hotspots_popup.hover(function(){
          hotspots.unbind('mousemove');
          clearTimeout(hotspots_popup_timeout);
        },function(){
          hotspots_enable_hotspots_popup();
        });
      }
      else {
        hotspots_popup_hide();
      }
    }

    /**
     * Hide popup
     */
    function hotspots_popup_hide() {
      hotspots_popup.fadeOut(200);
    }

    /**
     * Define eventing hotspots
     */
    function hotspots_detect_eventing_hotspots() {
      var eventing_hotspots = [];
      var clickedCoords = hotspots_get_clicked_coords();

      hotspots_fields.each(function(index, hotspot_form_element){
        var hotspot_coords = hotspots_get_coords_to_hotspot(hotspot_form_element);
        if (
          clickedCoords['x'] >= hotspot_coords['x1']
          && clickedCoords['x'] <= hotspot_coords['x2']
          && clickedCoords['y'] >= hotspot_coords['y1']
          && clickedCoords['y'] <= hotspot_coords['y2']
        ) {
          eventing_hotspots.push(hotspot_form_element);
        }
      });
      return  eventing_hotspots;
    }

    function hotspots_get_clicked_coords() {
      var clickedCoords = {};
      var hotspot_image_offset = $(hotspots_popup_event_object.currentTarget).offset();
      clickedCoords['x'] = hotspots_popup_event_object.pageX - hotspot_image_offset.left;
      clickedCoords['y'] = hotspots_popup_event_object.pageY - hotspot_image_offset.top;
      return clickedCoords;
    }

    /**
     * Get values from hotspots.
     */
    function hotspots_get_hotspots_values(hotspots) {
      var values = [];
      for (var index in hotspots) {
        var hotspot = hotspots[index];
        var value = {};
        value['title'] = $('.title', hotspot).val();
        value['value'] = $('.value', hotspot).val();
        values.push(value);
      }
      return values;
    }

  }
  
});

})(jQuery);

/**
 * Implementation drupal theme function theme('hotspots_hotspot').
 */
Drupal.theme.prototype.hotspots_hotspot = function (vars) {
  return '<div class="hotspot index-' + vars['hotspot_index'] + ' type-edit" style="' + vars['hotspot_styles'] + '"><div class="hotspot-inner"><div class="hotspot-inner2"></div></div></div>';
};

/**
 * Theme function
 */
Drupal.theme.prototype.hotspots_popup = function (values) {
  var output = '';
  for (var index in values) {
    var value = values[index];
    output += '<div class="hotspot-popup-element"><div class="title">' + value.title + '</div><div class="separator">:</div><div class="value">' + value.value + '</div></div>';
  }
  return output;
};